io.vertx.rxjava.core.file

## Class FileSystem

- java.lang.Object
- - io.vertx.rxjava.core.file.FileSystem

-     public class FileSystem
      extends Object

  Contains a broad set of operations for manipulating files on the file system.

  A (potential) blocking and non blocking version of each operation is provided.

  The non blocking versions take a handler which is called when the operation completes or an error occurs.

  The blocking versions are named `xxxBlocking` and return the results, or throw exceptions directly. In many cases, depending on the operating system and file system some of the potentially blocking operations can return quickly, which is why we provide them, but it's highly recommended that you test how long they take to return in your particular application before using them on an event loop.

  Please consult the documentation for more information on file system support.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FileSystem(FileSystem delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `FileSystem` | `chmod(String path, String perms, Handler<AsyncResult<Void>> handler)` Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chmodBlocking(String path, String perms)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `chmodObservable(String path, String perms)` Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chmodRecursive(String path, String perms, String dirPerms, Handler<AsyncResult<Void>> handler)` Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chmodRecursiveBlocking(String path, String perms, String dirPerms)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `chmodRecursiveObservable(String path, String perms, String dirPerms)` Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chown(String path, String user, String group, Handler<AsyncResult<Void>> handler)` Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
    `FileSystem` | `chownBlocking(String path, String user, String group)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `chownObservable(String path, String user, String group)` Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
    `FileSystem` | `copy(String from, String to, Handler<AsyncResult<Void>> handler)` Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `copyBlocking(String from, String to)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `copyObservable(String from, String to)` Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `copyRecursive(String from, String to, boolean recursive, Handler<AsyncResult<Void>> handler)` Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `copyRecursiveBlocking(String from, String to, boolean recursive)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `copyRecursiveObservable(String from, String to, boolean recursive)` Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `createFile(String path, Handler<AsyncResult<Void>> handler)` Creates an empty file with the specified `path`, asynchronously.
    `FileSystem` | `createFile(String path, String perms, Handler<AsyncResult<Void>> handler)` Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
    `FileSystem` | `createFileBlocking(String path)` Blocking version of `FileSystem`
    `FileSystem` | `createFileBlocking(String path, String perms)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `createFileObservable(String path)` Creates an empty file with the specified `path`, asynchronously.
    `rx.Observable<Void>` | `createFileObservable(String path, String perms)` Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
    `FileSystem` | `delete(String path, Handler<AsyncResult<Void>> handler)` Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `deleteBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `deleteObservable(String path)` Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `deleteRecursive(String path, boolean recursive, Handler<AsyncResult<Void>> handler)` Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `deleteRecursiveBlocking(String path, boolean recursive)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `deleteRecursiveObservable(String path, boolean recursive)` Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `exists(String path, Handler<AsyncResult<Boolean>> handler)` Determines whether the file as specified by the path `path` exists, asynchronously.
    `boolean` | `existsBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<Boolean>` | `existsObservable(String path)` Determines whether the file as specified by the path `path` exists, asynchronously.
    `FileSystem` | `fsProps(String path, Handler<AsyncResult<FileSystemProps>> handler)` Returns properties of the file-system being used by the specified `path`, asynchronously.
    `FileSystemProps` | `fsPropsBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<FileSystemProps>` | `fsPropsObservable(String path)` Returns properties of the file-system being used by the specified `path`, asynchronously.
    `Object` | `getDelegate()`
    `FileSystem` | `link(String link, String existing, Handler<AsyncResult<Void>> handler)` Create a hard link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `linkBlocking(String link, String existing)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `linkObservable(String link, String existing)` Create a hard link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `lprops(String path, Handler<AsyncResult<FileProps>> handler)` Obtain properties for the link represented by `path`, asynchronously.
    `FileProps` | `lpropsBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<FileProps>` | `lpropsObservable(String path)` Obtain properties for the link represented by `path`, asynchronously.
    `FileSystem` | `mkdir(String path, Handler<AsyncResult<Void>> handler)` Create the directory represented by `path`, asynchronously.
    `FileSystem` | `mkdir(String path, String perms, Handler<AsyncResult<Void>> handler)` Create the directory represented by `path`, asynchronously.
    `FileSystem` | `mkdirBlocking(String path)` Blocking version of `FileSystem`
    `FileSystem` | `mkdirBlocking(String path, String perms)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `mkdirObservable(String path)` Create the directory represented by `path`, asynchronously.
    `rx.Observable<Void>` | `mkdirObservable(String path, String perms)` Create the directory represented by `path`, asynchronously.
    `FileSystem` | `mkdirs(String path, Handler<AsyncResult<Void>> handler)` Create the directory represented by `path` and any non existent parents, asynchronously.
    `FileSystem` | `mkdirs(String path, String perms, Handler<AsyncResult<Void>> handler)` Create the directory represented by `path` and any non existent parents, asynchronously.
    `FileSystem` | `mkdirsBlocking(String path)` Blocking version of `FileSystem`
    `FileSystem` | `mkdirsBlocking(String path, String perms)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `mkdirsObservable(String path)` Create the directory represented by `path` and any non existent parents, asynchronously.
    `rx.Observable<Void>` | `mkdirsObservable(String path, String perms)` Create the directory represented by `path` and any non existent parents, asynchronously.
    `FileSystem` | `move(String from, String to, Handler<AsyncResult<Void>> handler)` Move a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `moveBlocking(String from, String to)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `moveObservable(String from, String to)` Move a file from the path `from` to path `to`, asynchronously.
    `static FileSystem` | `newInstance(FileSystem arg)`
    `FileSystem` | `open(String path, OpenOptions options, Handler<AsyncResult<AsyncFile>> handler)` Open the file represented by `path`, asynchronously.
    `AsyncFile` | `openBlocking(String path, OpenOptions options)` Blocking version of `FileSystem`
    `rx.Observable<AsyncFile>` | `openObservable(String path, OpenOptions options)` Open the file represented by `path`, asynchronously.
    `FileSystem` | `props(String path, Handler<AsyncResult<FileProps>> handler)` Obtain properties for the file represented by `path`, asynchronously.
    `FileProps` | `propsBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<FileProps>` | `propsObservable(String path)` Obtain properties for the file represented by `path`, asynchronously.
    `FileSystem` | `readDir(String path, Handler<AsyncResult<List<String>>> handler)` Read the contents of the directory specified by `path`, asynchronously.
    `FileSystem` | `readDir(String path, String filter, Handler<AsyncResult<List<String>>> handler)` Read the contents of the directory specified by `path`, asynchronously.
    `List<String>` | `readDirBlocking(String path)` Blocking version of `FileSystem`
    `List<String>` | `readDirBlocking(String path, String filter)` Blocking version of `FileSystem`
    `rx.Observable<List<String>>` | `readDirObservable(String path)` Read the contents of the directory specified by `path`, asynchronously.
    `rx.Observable<List<String>>` | `readDirObservable(String path, String filter)` Read the contents of the directory specified by `path`, asynchronously.
    `FileSystem` | `readFile(String path, Handler<AsyncResult<Buffer>> handler)` Reads the entire file as represented by the path `path` as a , asynchronously.
    `Buffer` | `readFileBlocking(String path)` Blocking version of `FileSystem`
    `rx.Observable<Buffer>` | `readFileObservable(String path)` Reads the entire file as represented by the path `path` as a , asynchronously.
    `FileSystem` | `readSymlink(String link, Handler<AsyncResult<String>> handler)` Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
    `String` | `readSymlinkBlocking(String link)` Blocking version of `FileSystem`
    `rx.Observable<String>` | `readSymlinkObservable(String link)` Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
    `FileSystem` | `symlink(String link, String existing, Handler<AsyncResult<Void>> handler)` Create a symbolic link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `symlinkBlocking(String link, String existing)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `symlinkObservable(String link, String existing)` Create a symbolic link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `truncate(String path, long len, Handler<AsyncResult<Void>> handler)` Truncate the file represented by `path` to length `len` in bytes, asynchronously.
    `FileSystem` | `truncateBlocking(String path, long len)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `truncateObservable(String path, long len)` Truncate the file represented by `path` to length `len` in bytes, asynchronously.
    `FileSystem` | `unlink(String link, Handler<AsyncResult<Void>> handler)` Unlinks the link on the file system represented by the path `link`, asynchronously.
    `FileSystem` | `unlinkBlocking(String link)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `unlinkObservable(String link)` Unlinks the link on the file system represented by the path `link`, asynchronously.
    `FileSystem` | `writeFile(String path, Buffer data, Handler<AsyncResult<Void>> handler)` Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
    `FileSystem` | `writeFileBlocking(String path, Buffer data)` Blocking version of `FileSystem`
    `rx.Observable<Void>` | `writeFileObservable(String path, Buffer data)` Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FileSystem

          public FileSystem(FileSystem delegate)

  - ### Method Detail

    - #### getDelegate

          public Object getDelegate()

    - #### copy

          public FileSystem copy(String from,
                                 String to,
                                 Handler<AsyncResult<Void>> handler)

      Copy a file from the path `from` to path `to`, asynchronously.

      The copy will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### copyObservable

          public rx.Observable<Void> copyObservable(String from,
                                                    String to)

      Copy a file from the path `from` to path `to`, asynchronously.

      The copy will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:

    - #### copyBlocking

          public FileSystem copyBlocking(String from,
                                         String to)

      Blocking version of `FileSystem`
      Parameters:
        `from` -
        `to` -
      Returns:

    - #### copyRecursive

          public FileSystem copyRecursive(String from,
                                          String to,
                                          boolean recursive,
                                          Handler<AsyncResult<Void>> handler)

      Copy a file from the path `from` to path `to`, asynchronously.

      If `recursive` is `true` and `from` represents a directory, then the directory and its contents will be copied recursively to the destination `to`.

      The copy will fail if the destination if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `recursive` -
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### copyRecursiveObservable

          public rx.Observable<Void> copyRecursiveObservable(String from,
                                                             String to,
                                                             boolean recursive)

      Copy a file from the path `from` to path `to`, asynchronously.

      If `recursive` is `true` and `from` represents a directory, then the directory and its contents will be copied recursively to the destination `to`.

      The copy will fail if the destination if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `recursive` -
      Returns:

    - #### copyRecursiveBlocking

          public FileSystem copyRecursiveBlocking(String from,
                                                  String to,
                                                  boolean recursive)

      Blocking version of `FileSystem`
      Parameters:
        `from` -
        `to` -
        `recursive` -
      Returns:

    - #### move

          public FileSystem move(String from,
                                 String to,
                                 Handler<AsyncResult<Void>> handler)

      Move a file from the path `from` to path `to`, asynchronously.

      The move will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### moveObservable

          public rx.Observable<Void> moveObservable(String from,
                                                    String to)

      Move a file from the path `from` to path `to`, asynchronously.

      The move will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:

    - #### moveBlocking

          public FileSystem moveBlocking(String from,
                                         String to)

      Blocking version of `FileSystem`
      Parameters:
        `from` -
        `to` -
      Returns:

    - #### truncate

          public FileSystem truncate(String path,
                                     long len,
                                     Handler<AsyncResult<Void>> handler)

      Truncate the file represented by `path` to length `len` in bytes, asynchronously.

      The operation will fail if the file does not exist or `len` is less than `zero`.

      Parameters:
        `path` - the path to the file
        `len` - the length to truncate it to
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### truncateObservable

          public rx.Observable<Void> truncateObservable(String path,
                                                        long len)

      Truncate the file represented by `path` to length `len` in bytes, asynchronously.

      The operation will fail if the file does not exist or `len` is less than `zero`.

      Parameters:
        `path` - the path to the file
        `len` - the length to truncate it to
      Returns:

    - #### truncateBlocking

          public FileSystem truncateBlocking(String path,
                                             long len)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `len` -
      Returns:

    - #### chmod

          public FileSystem chmod(String path,
                                  String perms,
                                  Handler<AsyncResult<Void>> handler)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified here.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### chmodObservable

          public rx.Observable<Void> chmodObservable(String path,
                                                     String perms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified here.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
      Returns:

    - #### chmodBlocking

          public FileSystem chmodBlocking(String path,
                                          String perms)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### chmodRecursive

          public FileSystem chmodRecursive(String path,
                                           String perms,
                                           String dirPerms,
                                           Handler<AsyncResult<Void>> handler)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified in {here}.

      If the file is directory then all contents will also have their permissions changed recursively. Any directory permissions will be set to `dirPerms`, whilst any normal file permissions will be set to `perms`.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
        `dirPerms` - the directory permissions
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### chmodRecursiveObservable

          public rx.Observable<Void> chmodRecursiveObservable(String path,
                                                              String perms,
                                                              String dirPerms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified in {here}.

      If the file is directory then all contents will also have their permissions changed recursively. Any directory permissions will be set to `dirPerms`, whilst any normal file permissions will be set to `perms`.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
        `dirPerms` - the directory permissions
      Returns:

    - #### chmodRecursiveBlocking

          public FileSystem chmodRecursiveBlocking(String path,
                                                   String perms,
                                                   String dirPerms)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `perms` -
        `dirPerms` -
      Returns:

    - #### chown

          public FileSystem chown(String path,
                                  String user,
                                  String group,
                                  Handler<AsyncResult<Void>> handler)

      Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
      Parameters:
        `path` - the path to the file
        `user` - the user name
        `group` - the user group
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### chownObservable

          public rx.Observable<Void> chownObservable(String path,
                                                     String user,
                                                     String group)

      Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
      Parameters:
        `path` - the path to the file
        `user` - the user name
        `group` - the user group
      Returns:

    - #### chownBlocking

          public FileSystem chownBlocking(String path,
                                          String user,
                                          String group)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `user` -
        `group` -
      Returns:

    - #### props

          public FileSystem props(String path,
                                  Handler<AsyncResult<FileProps>> handler)

      Obtain properties for the file represented by `path`, asynchronously.

      If the file is a link, the link will be followed.

      Parameters:
        `path` - the path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### propsObservable

          public rx.Observable<FileProps> propsObservable(String path)

      Obtain properties for the file represented by `path`, asynchronously.

      If the file is a link, the link will be followed.

      Parameters:
        `path` - the path to the file
      Returns:

    - #### propsBlocking

          public FileProps propsBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### lprops

          public FileSystem lprops(String path,
                                   Handler<AsyncResult<FileProps>> handler)

      Obtain properties for the link represented by `path`, asynchronously.

      The link will not be followed.

      Parameters:
        `path` - the path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### lpropsObservable

          public rx.Observable<FileProps> lpropsObservable(String path)

      Obtain properties for the link represented by `path`, asynchronously.

      The link will not be followed.

      Parameters:
        `path` - the path to the file
      Returns:

    - #### lpropsBlocking

          public FileProps lpropsBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### link

          public FileSystem link(String link,
                                 String existing,
                                 Handler<AsyncResult<Void>> handler)

      Create a hard link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### linkObservable

          public rx.Observable<Void> linkObservable(String link,
                                                    String existing)

      Create a hard link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:

    - #### linkBlocking

          public FileSystem linkBlocking(String link,
                                         String existing)

      Blocking version of `FileSystem`
      Parameters:
        `link` -
        `existing` -
      Returns:

    - #### symlink

          public FileSystem symlink(String link,
                                    String existing,
                                    Handler<AsyncResult<Void>> handler)

      Create a symbolic link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### symlinkObservable

          public rx.Observable<Void> symlinkObservable(String link,
                                                       String existing)

      Create a symbolic link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:

    - #### symlinkBlocking

          public FileSystem symlinkBlocking(String link,
                                            String existing)

      Blocking version of `FileSystem`
      Parameters:
        `link` -
        `existing` -
      Returns:

    - #### unlink

          public FileSystem unlink(String link,
                                   Handler<AsyncResult<Void>> handler)

      Unlinks the link on the file system represented by the path `link`, asynchronously.
      Parameters:
        `link` - the link
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### unlinkObservable

          public rx.Observable<Void> unlinkObservable(String link)

      Unlinks the link on the file system represented by the path `link`, asynchronously.
      Parameters:
        `link` - the link
      Returns:

    - #### unlinkBlocking

          public FileSystem unlinkBlocking(String link)

      Blocking version of `FileSystem`
      Parameters:
        `link` -
      Returns:

    - #### readSymlink

          public FileSystem readSymlink(String link,
                                        Handler<AsyncResult<String>> handler)

      Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
      Parameters:
        `link` - the link
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### readSymlinkObservable

          public rx.Observable<String> readSymlinkObservable(String link)

      Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
      Parameters:
        `link` - the link
      Returns:

    - #### readSymlinkBlocking

          public String readSymlinkBlocking(String link)

      Blocking version of `FileSystem`
      Parameters:
        `link` -
      Returns:

    - #### delete

          public FileSystem delete(String path,
                                   Handler<AsyncResult<Void>> handler)

      Deletes the file represented by the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### deleteObservable

          public rx.Observable<Void> deleteObservable(String path)

      Deletes the file represented by the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:

    - #### deleteBlocking

          public FileSystem deleteBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### deleteRecursive

          public FileSystem deleteRecursive(String path,
                                            boolean recursive,
                                            Handler<AsyncResult<Void>> handler)

      Deletes the file represented by the specified `path`, asynchronously.

      If the path represents a directory and `recursive = true` then the directory and its contents will be deleted recursively.

      Parameters:
        `path` - path to the file
        `recursive` - delete recursively?
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### deleteRecursiveObservable

          public rx.Observable<Void> deleteRecursiveObservable(String path,
                                                               boolean recursive)

      Deletes the file represented by the specified `path`, asynchronously.

      If the path represents a directory and `recursive = true` then the directory and its contents will be deleted recursively.

      Parameters:
        `path` - path to the file
        `recursive` - delete recursively?
      Returns:

    - #### deleteRecursiveBlocking

          public FileSystem deleteRecursiveBlocking(String path,
                                                    boolean recursive)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `recursive` -
      Returns:

    - #### mkdir

          public FileSystem mkdir(String path,
                                  Handler<AsyncResult<Void>> handler)

      Create the directory represented by `path`, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### mkdirObservable

          public rx.Observable<Void> mkdirObservable(String path)

      Create the directory represented by `path`, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
      Returns:

    - #### mkdirBlocking

          public FileSystem mkdirBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### mkdir

          public FileSystem mkdir(String path,
                                  String perms,
                                  Handler<AsyncResult<Void>> handler)

      Create the directory represented by `path`, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### mkdirObservable

          public rx.Observable<Void> mkdirObservable(String path,
                                                     String perms)

      Create the directory represented by `path`, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:

    - #### mkdirBlocking

          public FileSystem mkdirBlocking(String path,
                                          String perms)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### mkdirs

          public FileSystem mkdirs(String path,
                                   Handler<AsyncResult<Void>> handler)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### mkdirsObservable

          public rx.Observable<Void> mkdirsObservable(String path)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
      Returns:

    - #### mkdirsBlocking

          public FileSystem mkdirsBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### mkdirs

          public FileSystem mkdirs(String path,
                                   String perms,
                                   Handler<AsyncResult<Void>> handler)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### mkdirsObservable

          public rx.Observable<Void> mkdirsObservable(String path,
                                                      String perms)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:

    - #### mkdirsBlocking

          public FileSystem mkdirsBlocking(String path,
                                           String perms)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### readDir

          public FileSystem readDir(String path,
                                    Handler<AsyncResult<List<String>>> handler)

      Read the contents of the directory specified by `path`, asynchronously.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### readDirObservable

          public rx.Observable<List<String>> readDirObservable(String path)

      Read the contents of the directory specified by `path`, asynchronously.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the file
      Returns:

    - #### readDirBlocking

          public List<String> readDirBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### readDir

          public FileSystem readDir(String path,
                                    String filter,
                                    Handler<AsyncResult<List<String>>> handler)

      Read the contents of the directory specified by `path`, asynchronously.

      The parameter `filter` is a regular expression. If `filter` is specified then only the paths that match @{filter}will be returned.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the directory
        `filter` - the filter expression
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### readDirObservable

          public rx.Observable<List<String>> readDirObservable(String path,
                                                               String filter)

      Read the contents of the directory specified by `path`, asynchronously.

      The parameter `filter` is a regular expression. If `filter` is specified then only the paths that match @{filter}will be returned.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the directory
        `filter` - the filter expression
      Returns:

    - #### readDirBlocking

          public List<String> readDirBlocking(String path,
                                              String filter)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `filter` -
      Returns:

    - #### readFile

          public FileSystem readFile(String path,
                                     Handler<AsyncResult<Buffer>> handler)

      Reads the entire file as represented by the path `path` as a , asynchronously.

      Do not user this method to read very large files or you risk running out of available RAM.

      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### readFileObservable

          public rx.Observable<Buffer> readFileObservable(String path)

      Reads the entire file as represented by the path `path` as a , asynchronously.

      Do not user this method to read very large files or you risk running out of available RAM.

      Parameters:
        `path` - path to the file
      Returns:

    - #### readFileBlocking

          public Buffer readFileBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### writeFile

          public FileSystem writeFile(String path,
                                      Buffer data,
                                      Handler<AsyncResult<Void>> handler)

      Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `data` -
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFileObservable

          public rx.Observable<Void> writeFileObservable(String path,
                                                         Buffer data)

      Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `data` -
      Returns:

    - #### writeFileBlocking

          public FileSystem writeFileBlocking(String path,
                                              Buffer data)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `data` -
      Returns:

    - #### open

          public FileSystem open(String path,
                                 OpenOptions options,
                                 Handler<AsyncResult<AsyncFile>> handler)

      Open the file represented by `path`, asynchronously.

      The file is opened for both reading and writing. If the file does not already exist it will be created.

      Parameters:
        `path` - path to the file
        `options` - options describing how the file should be opened
        `handler` -
      Returns:
        a reference to this, so the API can be used fluently

    - #### openObservable

          public rx.Observable<AsyncFile> openObservable(String path,
                                                         OpenOptions options)

      Open the file represented by `path`, asynchronously.

      The file is opened for both reading and writing. If the file does not already exist it will be created.

      Parameters:
        `path` - path to the file
        `options` - options describing how the file should be opened
      Returns:

    - #### openBlocking

          public AsyncFile openBlocking(String path,
                                        OpenOptions options)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `options` -
      Returns:

    - #### createFile

          public FileSystem createFile(String path,
                                       Handler<AsyncResult<Void>> handler)

      Creates an empty file with the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### createFileObservable

          public rx.Observable<Void> createFileObservable(String path)

      Creates an empty file with the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:

    - #### createFileBlocking

          public FileSystem createFileBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### createFile

          public FileSystem createFile(String path,
                                       String perms,
                                       Handler<AsyncResult<Void>> handler)

      Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
      Parameters:
        `path` - path to the file
        `perms` - the permissions string
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### createFileObservable

          public rx.Observable<Void> createFileObservable(String path,
                                                          String perms)

      Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:

    - #### createFileBlocking

          public FileSystem createFileBlocking(String path,
                                               String perms)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### exists

          public FileSystem exists(String path,
                                   Handler<AsyncResult<Boolean>> handler)

      Determines whether the file as specified by the path `path` exists, asynchronously.
      Parameters:
        `path` - path to the file
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### existsObservable

          public rx.Observable<Boolean> existsObservable(String path)

      Determines whether the file as specified by the path `path` exists, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:

    - #### existsBlocking

          public boolean existsBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### fsProps

          public FileSystem fsProps(String path,
                                    Handler<AsyncResult<FileSystemProps>> handler)

      Returns properties of the file-system being used by the specified `path`, asynchronously.
      Parameters:
        `path` - path to anywhere on the filesystem
        `handler` - the handler that will be called on completion
      Returns:
        a reference to this, so the API can be used fluently

    - #### fsPropsObservable

          public rx.Observable<FileSystemProps> fsPropsObservable(String path)

      Returns properties of the file-system being used by the specified `path`, asynchronously.
      Parameters:
        `path` - path to anywhere on the filesystem
      Returns:

    - #### fsPropsBlocking

          public FileSystemProps fsPropsBlocking(String path)

      Blocking version of `FileSystem`
      Parameters:
        `path` -
      Returns:

    - #### newInstance

          public static FileSystem newInstance(FileSystem arg)

Copyright © 2015. All Rights Reserved.